Epoch:		1

%define gcj_support 	1
%define libgcj_major	6
%define libgcj		%mklibname gcj %{libgcj_major}
%define tomcatsharedir 	%{_datadir}/tomcat5
%define tomcatlibdir 	%{_var}/lib/tomcat5
%define pkg_summary     An open, extensible IDE
%define section         free
%define swt_version     3138
%define eclipse_major   3
%define eclipse_minor   1
%define eclipse_majmin  %{eclipse_major}.%{eclipse_minor}
%define eclipse_micro   0
%define eclipse_oldmajminmic  3.0.0
%define libname         libswt3
%define build_id        I20050627-1435

# All arches line up except i386 -> x86
%ifarch %{ix86}
%define eclipse_arch    x86
%else
%define eclipse_arch   %{_arch}
%endif

Summary:        %{pkg_summary}
Name:           eclipse
Version:        %{eclipse_majmin}.%{eclipse_micro}
Release:        %mkrel 8
License:        EPL
Group:          Development/Java
URL:            http://www.eclipse.org/
Source0: http://download.eclipse.org/eclipse/downloads/drops/I20050627-1435/eclipse-sourceBuild-srcIncluded-I20050627-1435.zip
Source1:        %{name}.script
Source2:        %{name}.desktop
Source5:        %{name}-48.png
Source6:        %{name}.conf
Source7:        %{name}-jdt.install
Source8:        %{name}-pde.install     
Source9:        %{name}-platform.install
Source10:       %{libname}-gtk2.install
Source11:	%{name}-native-splash-3.1.png
Source16:       %{name}-copy-platform.sh
Source17:       %{name}-efj-wrapper.sh
# this zip was taken from the M6 source drop
Source18:       ecj-M5.zip
Source19:       %{name}-filenamepatterns.txt

# Build libswt-mozilla
# https://bugs.eclipse.org/bugs/show_bug.cgi?id=71637
Patch0:         %{name}-make-linux.patch.bz2
# Build JNI libs
# FIXME:  these should be built by upstream build method
# http://www.bagu.org/eclipse/plugin-source-drops.html
# https://bugs.eclipse.org/bugs/show_bug.cgi?id=71637
# https://bugs.eclipse.org/bugs/show_bug.cgi?id=86848
# GNU XML issue identified by Michael Koch
Patch2:		%{name}-build.patch.bz2
Patch3:		%{name}-dontgeneratehelpindices.patch.bz2
Patch4:		%{name}-libupdatebuild.patch.bz2
Patch5:		%{name}-libupdatebuild2.patch.bz2
# Use installed mozilla libs and headers
Patch11:	%{name}-libswt-mozilla.patch.bz2
# We can't really commit to doing builds for these arches upstream, but we
# need at least eclipse-ecj to run on them as it's our bytecode compiler for
# Fedora.
#Patch13:	%{name}-s390ands390x.patch.bz2
# Stupid spaces in directories ...
#Patch14:	%{name}-s390ands390x2.patch.bz2
# Make find work.  See
# https://bugzilla.redhat.com/bugzilla/attachment.cgi?id=111736
#Patch16:	%{name}-find.patch.bz2
# Build swttools.jar
# https://bugs.eclipse.org/bugs/show_bug.cgi?id=90364
Patch18: 	%{name}-swttools.patch.bz2
# Add command-line source code formatter
# https://bugs.eclipse.org/bugs/show_bug.cgi?id=75333
Patch19: 	%{name}-efj.patch.bz2
# GNU-style JDT formatter
# https://bugs.eclipse.org/bugs/show_bug.cgi?id=91770
Patch20: 	%{name}-gnuformatterjdt.patch.bz2
Patch21: 	%{name}-gnuformatterjdtui.patch.bz2
# https://bugs.eclipse.org/bugs/show_bug.cgi?id=90630
Patch22: 	%{name}-updatehomedir.patch.bz2
# https://bugs.eclipse.org/bugs/show_bug.cgi?id=90535
Patch24: 	%{name}-fileinitializer.patch.bz2
# https://bugs.eclipse.org/bugs/show_bug.cgi?id=88364
Patch26: 	%{name}-ecj-options.patch.bz2
# https://bugs.eclipse.org/bugs/show_bug.cgi?id=98371
Patch28: 	%{name}-tomcat5.patch.bz2
Patch29: 	%{name}-tomcat5-build.patch.bz2
Patch30: 	%{name}-tomcat5-build.2.patch.bz2
Patch31: 	%{name}-webapp-tomcat5.patch.bz2
# Needs a patch for cairo 1.0
Patch32:	%{name}-swt-nocairo.fc4.patch.bz2
# https://bugs.eclipse.org/bugs/show_bug.cgi?id=98707 
Patch33:        %{name}-compare-create-api.patch.bz2
# https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=162177
Patch34:	%{name}-bz162177.patch.bz2
Patch35:	%{name}-javadoc.patch.bz2
# https://bugs.eclipse.org/bugs/show_bug.cgi?id=105430
Patch36:	%{name}-ecj-classpath.patch.bz2

%if %{gcj_support}
ExclusiveArch: %{ix86} x86_64 ppc
%else
BuildArch:	noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  perl
BuildRequires:  jpackage-utils >= 0:1.5, make, gcc
BuildRequires:  libgnome2-devel libgnomeui2-devel gnome-vfs2-devel
BuildRequires:  gtk2-devel
BuildRequires:  glib2-devel
#BuildRequires:  libgtkcairo-devel
BuildRequires:  gcc-c++
%ifnarch ppc64
BuildRequires:	mozilla-firefox
BuildRequires:  mozilla-firefox-devel
BuildRequires:  nspr-devel
BuildRequires:  X11-devel
%endif
%if %{gcj_support}
BuildRequires:	gcc-java >= 0:4.0.1
BuildRequires:	java-gcj-compat-devel >= 0:1.0.33
BuildRequires:  dos2unix
%else
BuildRequires:	java-devel >= 0:1.4.2
%endif

BuildRequires: ant-antlr ant-apache-bcel ant-apache-bsf ant-apache-log4j ant-apache-oro ant-apache-regexp ant-apache-resolver ant-commons-logging
BuildRequires: ant-commons-net ant-jai ant-jmf
BuildRequires: ant-javamail ant-jdepend ant-junit ant-nodeps ant-swing ant-trax ant-jsch
BuildRequires: jsch >= 0:0.1.18-1jpp
BuildRequires: jakarta-commons-beanutils jakarta-commons-collections jakarta-commons-digester jakarta-commons-dbcp jakarta-commons-el jakarta-commons-fileupload jakarta-commons-launcher jakarta-commons-logging jakarta-commons-modeler jakarta-commons-pool
BuildRequires: mx4j >= 0:2.1
BuildRequires: tomcat5 tomcat5-jasper tomcat5-servlet-2.4-api
BuildRequires: lucene lucene-demo
BuildRequires: regexp 
BuildRequires: junit >= 0:3.8.1
%if %{gcj_support}
Requires(post):   java-gcj-compat >= 0:1.0.33
Requires(postun): java-gcj-compat >= 0:1.0.33
%endif
BuildRequires:	eclipse-ecj

%description
The Eclipse Platform is designed for building integrated development
environments (IDEs) that can be used to create applications as diverse
as web sites, embedded Java(tm) programs, C++ programs, and Enterprise
JavaBeans(tm).

This version of eclipse contains native libraries for use by gij (the
default `java' command) in Mandriva contribs. If you use a version of
Java that does not support native libraries, everything should behave
normally.

To use a different version of Java to launch eclipse, set JAVA_HOME
before running /usr/bin/eclipse at the shell, or edit ~/.eclipserc and
add a JAVA_HOME= line to that file.

%package        ecj
Summary:        Eclipse Compiler for Java
Group:          Development/Java
Obsoletes:	ecj
Provides:	ecj
Obsoletes:	ecj-bootstrap
Provides:	ecj-bootstrap
%if %{gcj_support}
Requires:	%{libgcj} >= 0:4.0.1
Requires(post):	java-gcj-compat >= 0:1.0.33
Requires(postun): java-gcj-compat >= 0:1.0.33
%else
Requires:	java >= 0:1.4.2
%endif

%description    ecj
Eclipse compiler for Java.

%package        platform
Summary:        Eclipse platform common files
Group:          Development/Java
Provides:       %{name} = %{epoch}:%{version}-%{release}
Obsoletes:	%{name}-sdk %{name}-ui %{name}-gtk2 %{name}-scripts eclipse
Provides:	%{name}-sdk = %{epoch}:%{version}-%{release}
Provides:       %{name}-ui = %{epoch}:%{version}-%{release}
Provides:       %{name}-scripts = %{epoch}:%{version}-%{release}
Provides:       %{name}-gtk2 = %{epoch}:%{version}-%{release}
%if %{gcj_support}
Requires:       %{libgcj} >= 0:4.0.1
Requires:       java-gcj-compat >= 0:1.0.33
Requires(post):   java-gcj-compat >= 0:1.0.33
Requires(postun): java-gcj-compat >= 0:1.0.33
%else
Requires:       java >= 0:1.4.2
%endif
Requires:       %{name}-rcp = %{epoch}:%{version}-%{release}
Requires:       %{libname}-gtk2 = %{epoch}:%{version}-%{release}
Requires:       %{__perl}
# Used at runtime to find and set $MOZILLA_FIVE_HOME
Requires:       /usr/bin/mozilla-firefox-config

#PreReq:         gtk2 >= 0:2.6

Requires: ant-antlr ant-apache-bcel ant-apache-bsf ant-apache-log4j ant-apache-oro ant-apache-regexp ant-apache-resolver ant-commons-logging
Requires: ant-commons-net
Requires: ant-javamail ant-jdepend ant-junit ant-nodeps ant-swing ant-trax ant-jsch
Requires: jsch >= 0:0.1.18
Requires: jakarta-commons-beanutils jakarta-commons-collections jakarta-commons-digester jakarta-commons-dbcp jakarta-commons-el jakarta-commons-fileupload jakarta-commons-launcher jakarta-commons-logging jakarta-commons-modeler jakarta-commons-pool
Requires: mx4j >= 0:2.1
Requires: tomcat5 tomcat5-jasper tomcat5-servlet-2.4-api
Requires: lucene lucene-demo
Requires: regexp

%description    platform
Eclipse platform common files.  This package now contains the GTK2 UI (the
former eclipse-gtk2 package).

This version of eclipse contains native libraries for use by gij (the
default `java' command) in Mandriva contribs. If you use a version of
Java that does not support native libraries, everything should behave
normally.

To use a different version of Java to launch eclipse, set JAVA_HOME
before running /usr/bin/eclipse at the shell, or edit ~/.eclipserc and
add a JAVA_HOME= line to that file.

%package        platform-devel
Summary:        Eclipse platform Source
Group:          Development/Java
Requires:       %{name}-platform = %{epoch}:%{version}-%{release}

%description    platform-devel
Source for Eclipse platform for use within Eclipse.

%package        jdt
Summary:        Eclipse Java development tools
Group:          Development/Java
Requires:       %{name}-platform = %{epoch}:%{version}-%{release}
Requires:       %{name}-ecj = %{epoch}:%{version}-%{release}
Requires:       junit >= 0:3.8.1
%if %{gcj_support}
Requires:         %{libgcj} >= 0:4.0.1
Requires(post):   java-gcj-compat >= 0:1.0.33
Requires(postun): java-gcj-compat >= 0:1.0.33
%endif

%description    jdt
Eclipse Java developments tools.

%package        jdt-devel
Summary:        Eclipse JDT Source
Group:          Development/Java
Requires:       %{name}-jdt = %{epoch}:%{version}-%{release}

%description    jdt-devel
Source for JDT for use within Eclipse.

%package        pde
Summary:        Eclipse PDE
Group:          Development/Java
Requires:       %{name}-jdt = %{epoch}:%{version}-%{release}
Requires:       %{name}-platform-devel = %{epoch}:%{version}-%{release}
%if %{gcj_support}
Requires:       %{libgcj} >= 0:4.0.1
Requires(post):   java-gcj-compat >= 0:1.0.33
Requires(postun): java-gcj-compat >= 0:1.0.33
%endif

%package        pde-devel
Summary:        Eclipse PDE Source
Group:          Development/Java
Requires:       %{name}-pde = %{epoch}:%{version}-%{release}
Requires:       %{name}-jdt-devel = %{epoch}:%{version}-%{release}
Obsoletes:	%{name}-source
Provides:       %{name}-source = %{epoch}:%{version}-%{release}

%description    pde-devel
Source for PDE for use within Eclipse.

%description    pde
Eclipse PDE.

%package     -n %{libname}-gtk2
Summary:        SWT Library for GTK2
Group:          Development/Java
%if %{gcj_support}
Requires:       %{libgcj} >= 0:4.0.1
Requires(post):   java-gcj-compat >= 0:1.0.33
Requires(postun): java-gcj-compat >= 0:1.0.33
%endif

%description -n %{libname}-gtk2
SWT Library for GTK2.

%package        rcp
Summary:        Eclipse Rich Client Platform
Group:          Development/Java
%if %{gcj_support}
Requires:         %{libgcj} >= 0:4.0.1
Requires(post):   java-gcj-compat >= 0:1.0.33
Requires(postun): java-gcj-compat >= 0:1.0.33
%else
Requires:	java >= 0:1.4.2
%endif

%description    rcp
Eclipse Rich Client Platform

%package        rcp-devel
Summary:        Eclipse RCP Source
Group:          Development/Java
Requires:       %{name}-rcp = %{epoch}:%{version}-%{release}
Requires:       %{name}-jdt-devel = %{epoch}:%{version}-%{release}

%description    rcp-devel
Source for RCP for use within Eclipse.

%prep
%setup -q -c

# I hate spaces in paths with patch!
pushd plugins/org.eclipse.swt/Eclipse\ SWT\ PI/gtk/library
%patch0 -p0
%patch11 -p0
%if %{gcj_support}
#%patch14 -p0
%endif
popd
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%if %{gcj_support}
#%patch13 -p1
%endif
%if %{gcj_support}
#%patch16 -p0
%endif
pushd plugins/org.eclipse.swt.gtk.linux.x86_64
%patch18 -p0
popd
pushd plugins/org.eclipse.jdt.core
%patch19 -p0
#%patch20 -p0
popd
pushd plugins/org.eclipse.jdt.ui
#%patch21 -p0
popd
pushd plugins/org.eclipse.update.ui
%patch22 -p0
popd
pushd plugins/org.eclipse.core.runtime
%patch24 -p0
popd
pushd plugins/org.eclipse.tomcat
%patch28 -p0
%patch29 -p0
popd
%patch30 -p0
pushd plugins/org.eclipse.help.webapp
%patch31 -p0
popd
# Remove the pre-built cairo libraries
pushd plugins/org.eclipse.swt.gtk.linux.x86
rm libcairo.so.1
popd
pushd plugins/org.eclipse.swt.gtk.linux.x86_64
rm libcairo.so.1
popd
pushd plugins/org.eclipse.swt.motif.linux.x86
rm libcairo.so.1
popd
%patch32 -p0
pushd plugins/org.eclipse.compare
%patch33 -p0
popd
%patch34 -p1
%patch35 -p0
%patch36 -p1

%if %{gcj_support}
  # Fedora splash screen.
  %if 0
  pushd plugins/org.eclipse.platform
  cp %{SOURCE11} splash.bmp
  popd
  %endif

  # use M5 ecj rather than the one included
  cp %{SOURCE18} jdtcoresrc/src/ecj.zip

  # we need to add the ecj-options patch to the bootstrap compiler
  pushd jdtcoresrc/src
  unzip ecj.zip
  mv ecj.zip{,.orig}
  dos2unix org/eclipse/jdt/internal/compiler/batch/Main.java
  dos2unix org/eclipse/jdt/internal/compiler/batch/messages.properties
%patch26 -p1
  zip -9 -r ecj.zip *
  rm -r org
  popd
%endif

# Remove existing .sos
find -name \*.so -exec rm "-f" "{}" ";"

# Symlinks
rm -f plugins/org.eclipse.swt.tools/swttools.jar
rm -f plugins/org.eclipse.swt.win32.win32.x86/swt.jar
rm -f features/org.eclipse.platform.launchers/bin/startup.jar
## BEGIN ANT ##
ln -sf %{_javadir}/ant/ant-antlr.jar plugins/org.apache.ant/lib/ant-antlr.jar
ln -sf %{_javadir}/ant/ant-apache-bcel.jar plugins/org.apache.ant/lib/ant-apache-bcel.jar
ln -sf %{_javadir}/ant/ant-apache-bsf.jar plugins/org.apache.ant/lib/ant-apache-bsf.jar
ln -sf %{_javadir}/ant/ant-apache-log4j.jar plugins/org.apache.ant/lib/ant-apache-log4j.jar
ln -sf %{_javadir}/ant/ant-apache-oro.jar plugins/org.apache.ant/lib/ant-apache-oro.jar
ln -sf %{_javadir}/ant/ant-apache-regexp.jar plugins/org.apache.ant/lib/ant-apache-regexp.jar
ln -sf %{_javadir}/ant/ant-apache-resolver.jar plugins/org.apache.ant/lib/ant-apache-resolver.jar
ln -sf %{_javadir}/ant/ant-commons-logging.jar plugins/org.apache.ant/lib/ant-commons-logging.jar
ln -sf %{_javadir}/ant/ant-commons-net.jar plugins/org.apache.ant/lib/ant-commons-net.jar
ln -sf %{_javadir}/ant.jar plugins/org.apache.ant/lib/ant.jar
ln -sf %{_javadir}/ant/ant-javamail.jar plugins/org.apache.ant/lib/ant-javamail.jar
ln -sf %{_javadir}/ant/ant-jdepend.jar plugins/org.apache.ant/lib/ant-jdepend.jar
ln -sf %{_javadir}/ant/ant-jsch.jar plugins/org.apache.ant/lib/ant-jsch.jar
ln -sf %{_javadir}/ant/ant-junit.jar plugins/org.apache.ant/lib/ant-junit.jar
ln -sf %{_javadir}/ant-launcher.jar plugins/org.apache.ant/lib/ant-launcher.jar
ln -sf %{_javadir}/ant/ant-nodeps.jar plugins/org.apache.ant/lib/ant-nodeps.jar
ln -sf %{_javadir}/ant/ant-swing.jar plugins/org.apache.ant/lib/ant-swing.jar
ln -sf %{_javadir}/ant/ant-trax.jar plugins/org.apache.ant/lib/ant-trax.jar
ln -sf %{_javadir}/ant/ant-jai.jar plugins/org.apache.ant/lib/ant-jai.jar
ln -sf %{_javadir}/ant/ant-jmf.jar plugins/org.apache.ant/lib/ant-jmf.jar
# We used to ship these pre-built, but we're not going to do that anymore.  If
# we can build them using free stuff, we will. -- overholt, 2005-07-04
rm -f plugins/org.apache.ant/lib/ant-icontract.jar
rm -f plugins/org.apache.ant/lib/ant-netrexx.jar
rm -f plugins/org.apache.ant/lib/ant-starteam.jar
rm -f plugins/org.apache.ant/lib/ant-stylebook.jar
rm -f plugins/org.apache.ant/lib/ant-vaj.jar
rm -f plugins/org.apache.ant/lib/ant-weblogic.jar
rm -f plugins/org.apache.ant/lib/ant-xalan1.jar
rm -f plugins/org.apache.ant/lib/ant-xslp.jar
## END ANT ##
# BEGIN LUCENE ##
ln -sf %{_javadir}/lucene.jar plugins/org.apache.lucene/lucene-1.4.3.jar
ln -sf %{_datadir}/lucene/lucene-demos-1.4.3.jar plugins/org.apache.lucene/parser.jar
# END LUCENE ##
ln -sf %{_javadir}/jsch.jar plugins/org.eclipse.team.cvs.ssh2/jsch-0.1.18.jar
## BEGIN TOMCAT ##
rm -f plugins/org.eclipse.tomcat/commons-beanutils.jar
rm -f plugins/org.eclipse.tomcat/commons-collections.jar
rm -f plugins/org.eclipse.tomcat/commons-digester.jar
rm -f plugins/org.eclipse.tomcat/commons-logging-api.jar
rm -f plugins/org.eclipse.tomcat/commons-modeler.jar
rm -f plugins/org.eclipse.tomcat/jakarta-regexp-1.3.jar
rm -f plugins/org.eclipse.tomcat/servlet.jar
rm -f plugins/org.eclipse.tomcat/servlets-manager.jar
ln -sf %{tomcatsharedir}/bin/bootstrap.jar plugins/org.eclipse.tomcat/bootstrap.jar
ln -sf %{tomcatlibdir}/server/lib/catalina.jar plugins/org.eclipse.tomcat/catalina.jar
ln -sf %{tomcatlibdir}/server/lib/catalina-optional.jar plugins/org.eclipse.tomcat/catalina-optional.jar
ln -sf %{_javadir}/jakarta-commons-beanutils.jar plugins/org.eclipse.tomcat/jakarta-commons-beanutils.jar
ln -sf %{_javadir}/jakarta-commons-collections.jar plugins/org.eclipse.tomcat/jakarta-commons-collections.jar
ln -sf %{_javadir}/jakarta-commons-dbcp.jar plugins/org.eclipse.tomcat/jakarta-commons-dbcp.jar
ln -sf %{_javadir}/jakarta-commons-digester.jar plugins/org.eclipse.tomcat/jakarta-commons-digester.jar
ln -sf %{_javadir}/jakarta-commons-digester-rss.jar plugins/org.eclipse.tomcat/jakarta-commons-digester-rss.jar
ln -sf %{_javadir}/jakarta-commons-el.jar plugins/org.eclipse.tomcat/jakarta-commons-el.jar
ln -sf %{_javadir}/jakarta-commons-fileupload.jar plugins/org.eclipse.tomcat/jakarta-commons-fileupload.jar
ln -sf %{_javadir}/jakarta-commons-launcher.jar plugins/org.eclipse.tomcat/jakarta-commons-launcher.jar
ln -sf %{_javadir}/jakarta-commons-logging.jar plugins/org.eclipse.tomcat/jakarta-commons-logging.jar
ln -sf %{_javadir}/jakarta-commons-modeler.jar plugins/org.eclipse.tomcat/jakarta-commons-modeler.jar
ln -sf %{_javadir}/jakarta-commons-pool.jar plugins/org.eclipse.tomcat/jakarta-commons-pool.jar
ln -sf %{_javadir}/jasper5-compiler.jar  plugins/org.eclipse.tomcat/jasper-compiler.jar
ln -sf %{_javadir}/jasper5-runtime.jar plugins/org.eclipse.tomcat/jasper-runtime.jar
ln -sf %{_javadir}/jspapi.jar plugins/org.eclipse.tomcat/jspapi.jar
ln -sf %{_javadir}/mx4j/mx4j.jar plugins/org.eclipse.tomcat/mx4j.jar
ln -sf %{_javadir}/mx4j/mx4j-impl.jar plugins/org.eclipse.tomcat/mx4j-impl.jar
ln -sf %{_javadir}/mx4j/mx4j-jmx.jar plugins/org.eclipse.tomcat/mx4j-jmx.jar
ln -sf %{tomcatlibdir}/common/lib/naming-common.jar plugins/org.eclipse.tomcat/naming-common.jar
ln -sf %{tomcatlibdir}/common/lib/naming-factory.jar plugins/org.eclipse.tomcat/naming-factory.jar
ln -sf %{tomcatlibdir}/common/lib/naming-resources.jar plugins/org.eclipse.tomcat/naming-resources.jar
ln -sf %{_javadir}/regexp.jar plugins/org.eclipse.tomcat/regexp.jar
ln -sf %{_javadir}/servletapi5.jar plugins/org.eclipse.tomcat/servletapi5.jar
ln -sf %{tomcatlibdir}/server/lib/servlets-common.jar plugins/org.eclipse.tomcat/servlets-common.jar
ln -sf %{tomcatlibdir}/server/lib/servlets-default.jar plugins/org.eclipse.tomcat/servlets-default.jar
ln -sf %{tomcatlibdir}/server/lib/servlets-invoker.jar plugins/org.eclipse.tomcat/servlets-invoker.jar
ln -sf %{tomcatlibdir}/server/lib/tomcat-coyote.jar plugins/org.eclipse.tomcat/tomcat-coyote.jar
ln -sf %{tomcatlibdir}/server/lib/tomcat-http11.jar plugins/org.eclipse.tomcat/tomcat-http11.jar
ln -sf %{tomcatlibdir}/server/lib/tomcat-util.jar plugins/org.eclipse.tomcat/tomcat-util.jar
## END TOMCAT ##
ln -sf %{_javadir}/junit.jar plugins/org.junit/junit.jar

rm -f *.jar

pushd plugins/org.eclipse.swt/Eclipse\ SWT\ PI/gtk/library
# /usr/lib -> /usr/lib64
sed --in-place "s:/usr/lib/:%{_libdir}/:g" build.sh
%if %{gcj_support}
  # link against gcj's jawt implementation.
  sed --in-place "s/-ljawt/-lgcjawt/" make_linux.mak
%endif
popd


%build
ORIGCLASSPATH=$CLASSPATH

%if %{gcj_support}
  # Bootstrapping is 3 parts:
  # 1. Build ecj with gcj -C 
  # 2. Build ecj with gcj-built ecj ("javac")
  # 3. Re-build ecj with output of 2.
  
  # Unzip the "stable compiler" source into a temp dir and build it.
  # Note:  we don't want to build the CompilerAdapter.
  mkdir ecj-bootstrap-tmp
  unzip -qq -d ecj-bootstrap-tmp jdtcoresrc/src/ecj.zip
  rm -f ecj-bootstrap-tmp/org/eclipse/jdt/core/JDTCompilerAdapter.java
  
  # 1a. Build ecj with gcj -C
  pushd ecj-bootstrap-tmp
  for f in `find -name '*.java' | cut -c 3-`; do
      #gcj -Wno-deprecated -C $f
      ecj -classpath $(build-classpath libgcj-4.0.1.jar):. $f
  done
  find -name '*.class' -or -name '*.properties' -or -name '*.rsc' |\
      xargs jar cf ../ecj-bootstrap.jar
  popd
  
  # Delete our modified ecj and restore the backup
  rm -rf ecj-bootstrap-tmp
  
  ## 1b. Natively-compile it
  #gcj -fPIC -fjni -findirect-dispatch -shared -Wl,-Bsymbolic \
  #  -o ecj-bootstrap.jar.so ecj-bootstrap.jar
  # 
  #gcj-dbtool -n ecj-bootstrap.db 30000
  #gcj-dbtool -a ecj-bootstrap.db ecj-bootstrap.jar{,.so}
  
  ## 2a. Build ecj
  export CLASSPATH=ecj-bootstrap.jar:$ORIGCLASSPATH
  #export GCJ_PROPERTIES="gnu.gcj.precompiled.db.path=`pwd`/ecj-bootstrap.db"
%endif
%ant -buildfile jdtcoresrc/compilejdtcorewithjavac.xml \
    -DjavacFailOnError=true \
    -DjavacVerbose=false

%if %{gcj_support}
  ## 2b. Natively-compile ecj
  #gcj -fPIC -fjni -findirect-dispatch -shared -Wl,-Bsymbolic \
  #  -o jdtcoresrc/jdtcore.jar.so jdtcoresrc/jdtcore.jar
  #
  #gcj-dbtool -n jdtcoresrc/jdtcore.db 30000
  #gcj-dbtool -a jdtcoresrc/jdtcore.db jdtcoresrc/jdtcore.jar{,.so}
  #export GCJ_PROPERTIES="gnu.gcj.precompiled.db.path=`pwd`/jdtcoresrc/jdtcore.db"
  #
  ## Remove our gcj-built ecj
  #rm ecj-bootstrap.db ecj-bootstrap.jar
  rm ecj-bootstrap.jar
%endif

# 3. Use this ecj to rebuild itself
export CLASSPATH=`pwd`/jdtcoresrc/ecj.jar:$ORIGCLASSPATH
%ant -buildfile jdtcoresrc/compilejdtcore.xml \
    -DjavacFailOnError=true \
    -DjavacVerbose=false

%if %{gcj_support}
  ## Natively-compile it
  #gcj -fPIC -fjni -findirect-dispatch -shared -Wl,-Bsymbolic \
  #  -o jdtcore.jar.so jdtcore.jar
  #gcj-dbtool -n jdtcore.db 30000
  #gcj-dbtool -a jdtcore.db jdtcore.jar{,.so}
  #export GCJ_PROPERTIES="gnu.gcj.precompiled.db.path=`pwd`/jdtcore.db"
  #
  ## Remove old native bits
  #rm jdtcoresrc/jdtcore.db jdtcoresrc/jdtcore.jar.so
%endif

# Build the rest of Eclipse
export CLASSPATH=`pwd`/ecj.jar:$ORIGCLASSPATH
%ant \
  -Dnobootstrap=true \
  -DinstallOs=linux -DinstallWs=gtk -DinstallArch=%{eclipse_arch} \
  -Dlibsconfig=true \
  -DjavacFailOnError=true \
  -DjavacVerbose=false

# Hack to get the -debuginfo source code references
# to be pointing to the right place:
# Hardlink all the org.* source we can find
# Presumably, all the zipped source gets unzipped before compilation?
#src_root=$PWD/plugins
#pushd result
#mkdir -p eclipse/org
#collected_src_dir=$PWD/eclipse
#cat >copyallsrc <<-EOF
#	#! /bin/bash -peu
#	cd "\$1"
#	echo "Copying all .java source files from \$1 to $collected_src_dir..."
#	find . -type f -name '*.java' -print0 \
#	| xargs -0 -r cp -l --parents --target-directory=$collected_src_dir/org
#EOF
#chmod u+x copyallsrc
## Special case logic for SWT - only copy linux-gtk source
#find $src_root -type d -a \( -name org.eclipse.swt -prune -o -name org -print0 \) | xargs -l -0 ./copyallsrc
#./copyallsrc $src_root/org.eclipse.swt/Eclipse\ SWT/gtk/org
#popd

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}

tar -C $RPM_BUILD_ROOT%{_datadir} -zxf \
  result/linux-gtk-%{eclipse_arch}-sdk.tar.gz

pushd $RPM_BUILD_ROOT%{_datadir}/%{name}
# extract jdtCompilerAdapter.jar from org.eclipse.jdt.core_3.1.0.jar
unzip -d plugins plugins/org.eclipse.jdt.core_3.1.0.jar jdtCompilerAdapter.jar

# Extract .so files
# https://bugs.eclipse.org/bugs/show_bug.cgi?id=90535
java -cp startup.jar org.eclipse.core.launcher.Main -consolelog -application org.eclipse.core.runtime.initializer -fileInitializer %{SOURCE19}
popd

# Binaries, libraries, and natively-built shared libraries
install -d -m 755 $RPM_BUILD_ROOT%{_libdir}/%{name}

install -d -m 755 $RPM_BUILD_ROOT%{_bindir}

# Eclipse binary
mv $RPM_BUILD_ROOT%{_datadir}/%{name}/eclipse \
  $RPM_BUILD_ROOT%{_libdir}/%{name}/eclipse

pushd $RPM_BUILD_ROOT%{_datadir}/%{name}
ln -sf %{_libdir}/%{name}/eclipse eclipse

# Symlink JNI libraries
for l in `find configuration -name \*.so`; do
    mv $l $RPM_BUILD_ROOT%{_libdir}/%{name};
    pushd `dirname $l`;
      ln -sf %{_libdir}/%{name}/`basename $l`;
    popd;
    # SWT bundle stuff should go in libswt3-gtk
    # Contents of other bundles should go in eclipse-platform
    if [ "`basename $l`" = "libswt-gtk-%{swt_version}.so" ]
    then
        pushd `dirname $l`;
          cd ../..;
          currentDir=`pwd`;
          # Add this directory to the files list for libswt
          # This topmostDirs hack is needed due to differences in directory
          # layout between the build system and regular machines
          topmostDirs=`echo $currentDir | gawk -F '/' '{ print $2"-"$3 }'`;
          if [ "$topmostDirs" = "var-tmp" ]; then
            echo $currentDir | gawk -F '/' '{ print "/"$5"/"$6"/"$7"/"$8"/"$9"/"$10"/"$11"/"$12 }' > %{_builddir}/%{buildsubdir}/%{libname}-gtk2.install;
          else
            echo $currentDir | gawk -F '/' '{ print "/"$7"/"$8"/"$9"/"$10"/"$11"/"$12"/"$13"/"$14 }' > %{_builddir}/%{buildsubdir}/%{libname}-gtk2.install;
          fi
        popd
    elif [ "`basename $l`" = "libcore_3_1_0.so" ]; then
        pushd `dirname $l`;
          cd ../../../../..;
          currentDir=`pwd`;
          # Add this directory to the files list for eclipse-platform
          # This topmostDirs hack is needed due to differences in directory
          # layout between the build system and regular machines
          topmostDirs=`echo $currentDir | gawk -F '/' '{ print $2"-"$3 }'`;
          if [ "$topmostDirs" = "var-tmp" ]; then
            echo $currentDir | gawk -F '/' '{ print "/"$5"/"$6"/"$7"/"$8"/"$9"/"$10"/"$11"/"$12 }' >> %{_builddir}/%{buildsubdir}/%{name}-platform.install;
          else
            echo $currentDir | gawk -F '/' '{ print "/"$7"/"$8"/"$9"/"$10"/"$11"/"$12"/"$13"/"$14 }' >> %{_builddir}/%{buildsubdir}/%{name}-platform.install;
          fi
        popd
    elif [ "`basename $l`" = "libupdate.so" ]; then
        pushd `dirname $l`;
          cd ../../../../..;
          currentDir=`pwd`;
          # Add this directory to the files list for eclipse-platform
          # This topmostDirs hack is needed due to differences in directory
          # layout between the build system and regular machines
          topmostDirs=`echo $currentDir | gawk -F '/' '{ print $2"-"$3 }'`;
          if [ "$topmostDirs" = "var-tmp" ]; then
            echo $currentDir | gawk -F '/' '{ print "/"$5"/"$6"/"$7"/"$8"/"$9"/"$10"/"$11"/"$12 }' >> %{_builddir}/%{buildsubdir}/%{name}-platform.install;
          else
            echo $currentDir | gawk -F '/' '{ print "/"$7"/"$8"/"$9"/"$10"/"$11"/"$12"/"$13"/"$14 }' >> %{_builddir}/%{buildsubdir}/%{name}-platform.install;
          fi
        popd
    fi
done
popd

pushd $RPM_BUILD_ROOT%{_libdir}/%{name}
chmod -R 755 eclipse *.so
popd

### begin libswt-gtk2 symlinks
pushd $RPM_BUILD_ROOT%{_libdir}
for base in awt-gtk atk-gtk cairo-gtk mozilla-gtk gnome-gtk gtk pi-gtk; do
  test -f %{_libdir}/%{name}/libswt-${base}-%{swt_version}.so && \
  ln -sf %{_libdir}/%{name}/libswt-${base}-%{swt_version}.so \
         libswt-${base}-%{swt_version}.so || :
done
popd
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
pushd $RPM_BUILD_ROOT%{_javadir}
ln -sf %{_datadir}/%{name}/plugins/org.eclipse.swt.gtk.linux.%{eclipse_arch}_%{eclipse_majmin}.%{eclipse_micro}.jar swt-gtk-%{eclipse_majmin}.%{eclipse_micro}.jar
popd
### end libswt-gtk2 symlinks

# Launching script
mkdir -p $RPM_BUILD_ROOT%{_bindir}
perl -pe \
  's|/usr/lib/eclipse/|%{_libdir}/%{name}/|g ;
   s|/etc/|%{_sysconfdir}/|g ;
   s|/usr/bin/|%{_bindir}/|g' \
  %{SOURCE1} > $RPM_BUILD_ROOT%{_bindir}/eclipse
chmod a+x $RPM_BUILD_ROOT%{_bindir}/eclipse

# Default config
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}
perl -pe 's|/usr/lib/eclipse/|%{_datadir}/%{name}/|g' \
  %{SOURCE6} > $RPM_BUILD_ROOT%{_sysconfdir}/eclipse.conf

# rh/freedesktop.org icons
install -p -D -m0644 %{SOURCE5} \
  $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
install -d -m0755 $RPM_BUILD_ROOT%{_datadir}/pixmaps
ln -s ../icons/hicolor/48x48/apps/%{name}.png \
  $RPM_BUILD_ROOT%{_datadir}/pixmaps
install -d -m0755 $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps
ln -s ../../../../%{name}/plugins/org.eclipse.platform_%{eclipse_majmin}.%{eclipse_micro}/eclipse32.gif \
  $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
install -d -m0755 $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps
ln -s ../../../../%{name}/plugins/org.eclipse.platform_%{eclipse_majmin}.%{eclipse_micro}/eclipse.gif \
  $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
# Remove unused icon.xpm
rm -f $RPM_BUILD_ROOT%{_datadir}/%{name}/icon.xpm

# install the efj wrapper script and change the Eclipse installation dir
install -p -D -m0755 %{SOURCE17} $RPM_BUILD_ROOT%{_bindir}/efj
sed --in-place "s:startup.jar:%{_datadir}/%{name}/startup.jar:" \
  $RPM_BUILD_ROOT%{_bindir}/efj 

# A sanity check.
desktop-file-validate %{SOURCE2}

# freedesktop.org menu entry
install -p -D -m0644 %{SOURCE2} \
  $RPM_BUILD_ROOT%{_datadir}/applications/%{name}.desktop

cat %{SOURCE7} > %{name}-jdt.install
cat %{SOURCE8} > %{name}-pde.install
cat %{SOURCE9} >> %{name}-platform.install
cat %{SOURCE10} >> %{libname}-gtk2.install

cat >> $RPM_BUILD_ROOT%{_datadir}/%{name}/.eclipseproduct << EOF
name=Eclipse Platform
id=org.eclipse.platform
version=%{eclipse_majmin}.%{eclipse_micro}
EOF

# Create a script that can be used to make a symlink tree of the
# eclipse platform.
cp %{SOURCE16} copy-platform
(
  cd $RPM_BUILD_ROOT%{_datadir}/%{name}
  ls -d * | egrep -v '^(plugins|features)$'
  ls -d plugins/* features/*
) |
sed -e's/^\(.*\)$/\1 \1/' -e's,^,ln -s $eclipse/,' >> copy-platform

chmod 755 copy-platform

mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}/buildscripts
cp copy-platform $RPM_BUILD_ROOT%{_datadir}/%{name}/buildscripts

pushd $RPM_BUILD_ROOT%{_datadir}/%{name}
## BEGIN ANT ##
ln -sf %{_javadir}/ant/ant-antlr.jar plugins/org.apache.ant_*/lib/ant-antlr.jar
ln -sf %{_javadir}/ant/ant-apache-bcel.jar plugins/org.apache.ant_*/lib/ant-apache-bcel.jar
ln -sf %{_javadir}/ant/ant-apache-bsf.jar plugins/org.apache.ant_*/lib/ant-apache-bsf.jar
ln -sf %{_javadir}/ant/ant-apache-log4j.jar plugins/org.apache.ant_*/lib/ant-apache-log4j.jar
ln -sf %{_javadir}/ant/ant-apache-oro.jar plugins/org.apache.ant_*/lib/ant-apache-oro.jar
ln -sf %{_javadir}/ant/ant-apache-regexp.jar plugins/org.apache.ant_*/lib/ant-apache-regexp.jar
ln -sf %{_javadir}/ant/ant-apache-resolver.jar plugins/org.apache.ant_*/lib/ant-apache-resolver.jar
ln -sf %{_javadir}/ant/ant-commons-logging.jar plugins/org.apache.ant_*/lib/ant-commons-logging.jar
ln -sf %{_javadir}/ant/ant-commons-net.jar plugins/org.apache.ant_*/lib/ant-commons-net.jar
ln -sf %{_javadir}/ant.jar plugins/org.apache.ant_*/lib/ant.jar
ln -sf %{_javadir}/ant/ant-javamail.jar plugins/org.apache.ant_*/lib
ln -sf %{_javadir}/ant/ant-jdepend.jar plugins/org.apache.ant_*/lib/ant-jdepend.jar
ln -sf %{_javadir}/ant/ant-jsch.jar plugins/org.apache.ant_*/lib/ant-jsch.jar
ln -sf %{_javadir}/ant/ant-junit.jar plugins/org.apache.ant_*/lib/ant-junit.jar
ln -sf %{_javadir}/ant-launcher.jar plugins/org.apache.ant_*/lib/ant-launcher.jar
ln -sf %{_javadir}/ant/ant-nodeps.jar plugins/org.apache.ant_*/lib/ant-nodeps.jar
ln -sf %{_javadir}/ant/ant-swing.jar plugins/org.apache.ant_*/lib/ant-swing.jar
ln -sf %{_javadir}/ant/ant-trax.jar plugins/org.apache.ant_*/lib/ant-trax.jar
ln -sf %{_javadir}/ant/ant-jai.jar plugins/org.apache.ant_*/lib/ant-jai.jar
ln -sf %{_javadir}/ant/ant-jmf.jar plugins/org.apache.ant_*/lib/ant-jmf.jar
# We used to ship these pre-built, but we're not going to do that anymore.  If
# we can build them using free stuff, we will. -- overholt, 2005-07-04
rm -f plugins/org.apache.ant_*/lib/ant-icontract.jar
rm -f plugins/org.apache.ant_*/lib/ant-netrexx.jar
rm -f plugins/org.apache.ant_*/lib/ant-starteam.jar
rm -f plugins/org.apache.ant_*/lib/ant-stylebook.jar
rm -f plugins/org.apache.ant_*/lib/ant-vaj.jar
rm -f plugins/org.apache.ant_*/lib/ant-weblogic.jar
rm -f plugins/org.apache.ant_*/lib/ant-xalan1.jar
rm -f plugins/org.apache.ant_*/lib/ant-xslp.jar
## END ANT ##
# BEGIN LUCENE ##
ln -sf %{_javadir}/lucene.jar plugins/org.apache.lucene_*/lucene-1.4.3.jar
ln -sf %{_datadir}/lucene/lucene-demos-1.4.3.jar plugins/org.apache.lucene_*/parser.jar
# END LUCENE ##
ln -sf %{_javadir}/jsch.jar plugins/org.eclipse.team.cvs.ssh2_*/jsch-0.1.18.jar
## BEGIN TOMCAT ##
rm -f plugins/org.eclipse.tomcat_*/commons-beanutils.jar
rm -f plugins/org.eclipse.tomcat_*/commons-collections.jar
rm -f plugins/org.eclipse.tomcat_*/commons-digester.jar
rm -f plugins/org.eclipse.tomcat_*/commons-logging-api.jar
rm -f plugins/org.eclipse.tomcat_*/commons-modeler.jar
rm -f plugins/org.eclipse.tomcat_*/jakarta-regexp-1.3.jar
rm -f plugins/org.eclipse.tomcat_*/servlet.jar
rm -f plugins/org.eclipse.tomcat_*/servlets-manager.jar
ln -sf %{tomcatsharedir}/bin/bootstrap.jar plugins/org.eclipse.tomcat_*/bootstrap.jar
ln -sf %{tomcatlibdir}/server/lib/catalina.jar plugins/org.eclipse.tomcat_*/catalina.jar
ln -sf %{tomcatlibdir}/server/lib/catalina-optional.jar plugins/org.eclipse.tomcat_*/catalina-optional.jar
ln -sf %{_javadir}/jakarta-commons-beanutils.jar plugins/org.eclipse.tomcat_*/jakarta-commons-beanutils.jar
ln -sf %{_javadir}/jakarta-commons-collections.jar plugins/org.eclipse.tomcat_*/jakarta-commons-collections.jar
ln -sf %{_javadir}/jakarta-commons-dbcp.jar plugins/org.eclipse.tomcat_*/jakarta-commons-dbcp.jar
ln -sf %{_javadir}/jakarta-commons-digester.jar plugins/org.eclipse.tomcat_*/jakarta-commons-digester.jar
ln -sf %{_javadir}/jakarta-commons-digester-rss.jar plugins/org.eclipse.tomcat_*/jakarta-commons-digester-rss.jar
ln -sf %{_javadir}/jakarta-commons-el.jar plugins/org.eclipse.tomcat_*/jakarta-commons-el.jar
ln -sf %{_javadir}/jakarta-commons-fileupload.jar plugins/org.eclipse.tomcat_*/jakarta-commons-fileupload.jar
ln -sf %{_javadir}/jakarta-commons-launcher.jar plugins/org.eclipse.tomcat_*/jakarta-commons-launcher.jar
ln -sf %{_javadir}/jakarta-commons-logging.jar plugins/org.eclipse.tomcat_*/jakarta-commons-logging.jar
ln -sf %{_javadir}/jakarta-commons-modeler.jar plugins/org.eclipse.tomcat_*/jakarta-commons-modeler.jar
ln -sf %{_javadir}/jakarta-commons-pool.jar plugins/org.eclipse.tomcat_*/jakarta-commons-pool.jar
ln -sf %{_javadir}/jasper5-compiler.jar  plugins/org.eclipse.tomcat_*/jasper-compiler.jar
ln -sf %{_javadir}/jasper5-runtime.jar plugins/org.eclipse.tomcat_*/jasper-runtime.jar
ln -sf %{_javadir}/jspapi.jar plugins/org.eclipse.tomcat_*/jspapi.jar
ln -sf %{_javadir}/mx4j/mx4j.jar plugins/org.eclipse.tomcat_*/mx4j.jar
ln -sf %{_javadir}/mx4j/mx4j-impl.jar plugins/org.eclipse.tomcat_*/mx4j-impl.jar
ln -sf %{_javadir}/mx4j/mx4j-jmx.jar plugins/org.eclipse.tomcat_*/mx4j-jmx.jar
ln -sf %{tomcatlibdir}/common/lib/naming-common.jar plugins/org.eclipse.tomcat_*/naming-common.jar
ln -sf %{tomcatlibdir}/common/lib/naming-factory.jar plugins/org.eclipse.tomcat_*/naming-factory.jar
ln -sf %{tomcatlibdir}/common/lib/naming-resources.jar plugins/org.eclipse.tomcat_*/naming-resources.jar
ln -sf %{_javadir}/regexp.jar plugins/org.eclipse.tomcat_*/regexp.jar
ln -sf %{_javadir}/servletapi5.jar plugins/org.eclipse.tomcat_*/servletapi5.jar
ln -sf %{tomcatlibdir}/server/lib/servlets-common.jar plugins/org.eclipse.tomcat_*/servlets-common.jar
ln -sf %{tomcatlibdir}/server/lib/servlets-default.jar plugins/org.eclipse.tomcat_*/servlets-default.jar
ln -sf %{tomcatlibdir}/server/lib/servlets-invoker.jar plugins/org.eclipse.tomcat_*/servlets-invoker.jar
ln -sf %{tomcatlibdir}/server/lib/tomcat-coyote.jar plugins/org.eclipse.tomcat_*/tomcat-coyote.jar
ln -sf %{tomcatlibdir}/server/lib/tomcat-http11.jar plugins/org.eclipse.tomcat_*/tomcat-http11.jar
ln -sf %{tomcatlibdir}/server/lib/tomcat-util.jar plugins/org.eclipse.tomcat_*/tomcat-util.jar
## END TOMCAT ##
ln -sf %{_javadir}/junit.jar plugins/org.junit_*/junit.jar

pushd plugins/org.apache.ant_*/bin
rm -f *.bat *.cmd
for i in ant antRun antRun.pl complete-ant-cmd.pl runant.pl runant.py; do
  ln -sf %{_bindir}/$i $i
done
popd

# Symlink org.eclipse.jdt.core_%{eclipse_majmin}.%{eclipse_micro}.jar in
# %{_datadir}/java/eclipse-ecj.jar for java-1.4.2-gcj-compat's "javac"
mkdir -p $RPM_BUILD_ROOT%{_datadir}/java
ln -s %{_datadir}/%{name}/plugins/org.eclipse.jdt.core_%{eclipse_majmin}.%{eclipse_micro}.jar \
  $RPM_BUILD_ROOT%{_datadir}/java/eclipse-ecj.jar

%if %{gcj_support}
# FIXME:  temporarily disable org.eclipse.ui.forms_3.1.0.jar.so 
# see:  https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=146463
# FIXME:  temporarily disable org.eclipse.ui.workbench_3.1.0.jar.so
# see:  https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=151919
# FIXME:  temporarily disable org.eclipse.osgi_3.1.0.jar.so
# see: https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=158137
%ifarch x86_64
%{__mkdir_p} %{buildroot}%{_libdir}/gcj/%{name}
%{_bindir}/gcj -shared -O -pipe -Wp,-D_FORTIFY_SOURCE=2 -fPIC -findirect-dispatch -fjni -Wl,-Bsymbolic \
%{buildroot}%{_datadir}/%{name}/plugins/org.eclipse.platform_%{eclipse_majmin}.%{eclipse_micro}/startup.jar \
-o %{buildroot}%{_libdir}/gcj/%{name}/startup.jar.so
%endif
%{_jvmdir}/java-1.4.2-gcj/bin/aot-compile-rpm \
--exclude %{_datadir}/%{name}/plugins/org.eclipse.ui.workbench_%{eclipse_majmin}.%{eclipse_micro}.jar \
--exclude %{_datadir}/%{name}/plugins/org.eclipse.ui.forms_%{eclipse_majmin}.%{eclipse_micro}.jar \
--exclude %{_datadir}/%{name}/plugins/org.eclipse.osgi_%{eclipse_majmin}.%{eclipse_micro}.jar

# Build and install ecj binary
pushd $RPM_BUILD_ROOT%{_libdir}/gcj/%{name}
  gcj -g -O2 --main=org.eclipse.jdt.internal.compiler.batch.Main \
    -Wl,-R,%{_libdir}/gcj/%{name} \
    org.eclipse.jdt.core_3.1.0.jar.so jdtCompilerAdapter.jar.so -o \
    $RPM_BUILD_ROOT%{_bindir}/ecj
popd
chmod a+x $RPM_BUILD_ROOT%{_bindir}/ecj
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{gcj_support}
%post ecj
%{_bindir}/rebuild-gcj-db

%post jdt
%{_bindir}/rebuild-gcj-db

%post pde
%{_bindir}/rebuild-gcj-db

%post rcp
%{_bindir}/rebuild-gcj-db

%post -n %{libname}-gtk2
%{_bindir}/rebuild-gcj-db
%endif

%post platform
%if %{gcj_support}
%{_bindir}/rebuild-gcj-db
%endif
touch --no-create %{_datadir}/icons/hicolor
if [ -x /usr/bin/gtk-update-icon-cache ]; then
  gtk-update-icon-cache -q %{_datadir}/icons/hicolor
fi

%if %{gcj_support}
%postun ecj
%{_bindir}/rebuild-gcj-db

%postun jdt
%{_bindir}/rebuild-gcj-db

%postun pde
%{_bindir}/rebuild-gcj-db

%postun rcp
%{_bindir}/rebuild-gcj-db

%postun -n %{libname}-gtk2
%{_bindir}/rebuild-gcj-db
%endif

%postun platform
%if %{gcj_support}
%{_bindir}/rebuild-gcj-db
%endif
touch --no-create %{_datadir}/icons/hicolor
if [ -x /usr/bin/gtk-update-icon-cache ]; then
  gtk-update-icon-cache -q %{_datadir}/icons/hicolor
fi

%files ecj
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/plugins
%dir %{_datadir}/%{name}/features
%dir %{_datadir}/%{name}/configuration
%{_datadir}/%{name}/plugins/org.eclipse.jdt.core_3.*
%{_datadir}/%{name}/plugins/jdtCompilerAdapter.jar
%{_datadir}/java/eclipse-ecj.jar
%if %{gcj_support}
# Native bits
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/org.eclipse.jdt.core_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.jdt.core_3.1.0.jar.db
%{_libdir}/gcj/%{name}/jdtCompilerAdapter.jar.so
%{_libdir}/gcj/%{name}/jdtCompilerAdapter.jar.db
%{_bindir}/ecj
%endif

%files -n %{libname}-gtk2 -f %{libname}-gtk2.install
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/plugins
%dir %{_datadir}/%{name}/features
%dir %{_datadir}/%{name}/configuration
%dir %{_datadir}/%{name}/configuration/org.eclipse.osgi
%dir %{_datadir}/%{name}/configuration/org.eclipse.osgi/bundles
# %{_datadir}/%{name}/configuration/org.eclipse.osgi/bundles/%{swt_bundle_id} is
# in libswt3-gtk2.install
%{_libdir}/%{name}/libswt-*.so
%{_libdir}/libswt-*.so
%{_javadir}/swt-gtk*.jar
%if %{gcj_support}
# Native bits
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/org.eclipse.jface_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.jface_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.jface.text_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.jface.text_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.swt.gtk.linux.%{eclipse_arch}_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.swt.gtk.linux.%{eclipse_arch}_3.1.0.jar.so
%endif

%files jdt -f %{name}-jdt.install
%{_bindir}/efj
%if %{gcj_support}
# Native bits
%{_libdir}/gcj/%{name}/org.eclipse.jdt.debug.ui_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.jdt.debug.ui_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.jdt.launching_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.jdt.launching_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.jdt.ui_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.jdt.ui_3.1.0.jar.so
%{_libdir}/gcj/%{name}/junitruntime.jar.db
%{_libdir}/gcj/%{name}/junitruntime.jar.so
%{_libdir}/gcj/%{name}/junitsupport.jar.db
%{_libdir}/gcj/%{name}/junitsupport.jar.so
%{_libdir}/gcj/%{name}/jdimodel.jar.db
%{_libdir}/gcj/%{name}/jdimodel.jar.so
%{_libdir}/gcj/%{name}/jdi.jar.db
%{_libdir}/gcj/%{name}/jdi.jar.so
%endif

%files jdt-devel
%{_datadir}/%{name}/plugins/org.eclipse.jdt.source_3.*
%{_datadir}/%{name}/features/org.eclipse.jdt.source_3.*

%files pde -f %{name}-pde.install
%if %{gcj_support}
# Native bits
%{_libdir}/gcj/%{name}/pdebuild.jar.so
%{_libdir}/gcj/%{name}/pdebuild.jar.db
%{_libdir}/gcj/%{name}/pdebuild-ant.jar.so
%{_libdir}/gcj/%{name}/pdebuild-ant.jar.db
%{_libdir}/gcj/%{name}/pdejunit.jar.so
%{_libdir}/gcj/%{name}/pdejunit.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.pde.core_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.pde.core_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.pde.runtime_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.pde.runtime_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.pde.ui_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.pde.ui_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.pde_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.pde_3.1.0.jar.db
%endif

%files pde-devel
%{_datadir}/%{name}/plugins/org.eclipse.pde.source_3.*
%{_datadir}/%{name}/features/org.eclipse.pde.source_3.*

%files rcp
%{_datadir}/%{name}/features/org.eclipse.rcp_3.*
%{_datadir}/%{name}/plugins/org.eclipse.rcp_3.*

%files rcp-devel
%{_datadir}/%{name}/plugins/org.eclipse.rcp.source_3.*
%{_datadir}/%{name}/plugins/org.eclipse.rcp.source.linux*
%{_datadir}/%{name}/features/org.eclipse.rcp.source_3.*

%files platform -f %{name}-platform.install
%ifnarch ppc
%{_datadir}/%{name}/about.html
%{_datadir}/%{name}/about_files
%endif
%{_datadir}/%{name}/.eclipseproduct
%{_datadir}/%{name}/startup.jar
%{_datadir}/%{name}/buildscripts
%{_libdir}/%{name}/eclipse
%{_libdir}/%{name}/libcore*
%{_libdir}/%{name}/libupdate*
# This is all from our FileInitializer extraction of .sos
# all extracted bundles other than SWT will be in eclipse-platform.install
%dir %{_datadir}/%{name}/configuration
%dir %{_datadir}/%{name}/configuration/org.eclipse.osgi
%dir %{_datadir}/%{name}/configuration/org.eclipse.osgi/bundles
%{_datadir}/%{name}/configuration/org.eclipse.osgi/.bundledata*
%{_datadir}/%{name}/configuration/org.eclipse.osgi/.lazy*
%{_datadir}/%{name}/configuration/org.eclipse.osgi/.manager
%{_datadir}/%{name}/configuration/org.eclipse.osgi/.state*
%{_datadir}/%{name}/configuration/config.ini
%{_datadir}/%{name}/configuration/org.eclipse.core.runtime
%{_datadir}/%{name}/configuration/org.eclipse.update
%{_datadir}/%{name}/eclipse
%{_bindir}/eclipse
%{_datadir}/applications/*
%{_datadir}/pixmaps/*
%{_datadir}/icons/*/*/apps/*
%config(noreplace) %{_sysconfdir}/eclipse.conf
%if %{gcj_support}
# Native bits
%{_libdir}/gcj/%{name}/startup.jar.so
%{_libdir}/gcj/%{name}/startup.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.core.commands_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.core.commands_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.core.expressions_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.core.expressions_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.core.filebuffers_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.core.filebuffers_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.core.resources_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.core.resources_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.core.resources.compatibility_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.core.resources.compatibility_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.core.runtime_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.core.runtime_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.core.runtime.compatibility_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.core.runtime.compatibility_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.core.variables_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.core.variables_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.help_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.help_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.help.appserver_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.help.appserver_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.help.base_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.help.base_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.help.ui_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.help.ui_3.1.0.jar.so
%{_libdir}/gcj/%{name}/jsp.jar.db
%{_libdir}/gcj/%{name}/jsp.jar.so
%{_libdir}/gcj/%{name}/servlets.jar.db
%{_libdir}/gcj/%{name}/servlets.jar.so
%{_libdir}/gcj/%{name}/webapp.jar.db
%{_libdir}/gcj/%{name}/webapp.jar.so
%{_libdir}/gcj/%{name}/tomcatwrapper.jar.db
%{_libdir}/gcj/%{name}/tomcatwrapper.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.ui_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.ui_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.ui.browser_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.ui.browser_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.ui.cheatsheets_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.ui.cheatsheets_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.ui.console_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.ui.console_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.ui.editors_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.ui.editors_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.ui.externaltools_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.ui.externaltools_3.1.0.jar.so
# FIXME:  temporarily disable org.eclipse.ui.forms_3.1.0.jar.so 
# see:  https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=146463
#%{_libdir}/gcj/%{name}/org.eclipse.ui.forms_3.1.0.jar.db
#%{_libdir}/gcj/%{name}/org.eclipse.ui.forms_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.ui.ide_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.ui.ide_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.ui.intro_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.ui.intro_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.ui.presentations.r21_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.ui.presentations.r21_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.ui.views_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.ui.views_3.1.0.jar.so
# FIXME:  temporarily disable org.eclipse.ui.workbench_3.1.0.jar.so
# see:  https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=151919
#%{_libdir}/gcj/%{name}/org.eclipse.ui.workbench_3.1.0.jar.so
#%{_libdir}/gcj/%{name}/org.eclipse.ui.workbench_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.ui.workbench.texteditor_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.ui.workbench.texteditor_3.1.0.jar.so
%{_libdir}/gcj/%{name}/compatibility.jar.db
%{_libdir}/gcj/%{name}/compatibility.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.update.configurator_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.update.configurator_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.update.core_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.update.core_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.update.scheduler_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.update.scheduler_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.update.ui_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.update.ui_3.1.0.jar.so
# FIXME:  temporarily disable org.eclipse.osgi_3.1.0.jar.so
# see: https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=158137
#%{_libdir}/gcj/%{name}/org.eclipse.osgi_3.1.0.jar.so
#%{_libdir}/gcj/%{name}/org.eclipse.osgi_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.osgi.services_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.osgi.services_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.osgi.util_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.osgi.util_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.ant.core_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.ant.core_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.ant.ui_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.ant.ui_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.compare_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.compare_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.debug.core_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.debug.core_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.debug.ui_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.debug.ui_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.ltk.ui.refactoring_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.ltk.ui.refactoring_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.ltk.core.refactoring_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.ltk.core.refactoring_3.1.0.jar.db
%{_libdir}/gcj/%{name}/activeHelpSample.jar.db
%{_libdir}/gcj/%{name}/activeHelpSample.jar.so
%{_libdir}/gcj/%{name}/platform.jar.db
%{_libdir}/gcj/%{name}/platform.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.team.core_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.team.core_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.team.cvs.core_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.team.cvs.core_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.team.cvs.ssh_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.team.cvs.ssh_3.1.0.jar.so
%{_libdir}/gcj/%{name}/cvsssh2.jar.so
%{_libdir}/gcj/%{name}/cvsssh2.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.team.cvs.ui_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.team.cvs.ui_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.team.ui_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.team.ui_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.search_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.search_3.1.0.jar.db
%{_libdir}/gcj/%{name}/org.eclipse.text_3.1.0.jar.so
%{_libdir}/gcj/%{name}/org.eclipse.text_3.1.0.jar.db
%endif

%files platform-devel
%{_datadir}/%{name}/plugins/org.eclipse.platform.source_3.*
%{_datadir}/%{name}/features/org.eclipse.platform.source_3.*
%{_datadir}/%{name}/plugins/org.eclipse.platform.source.linux.gtk.*_3.1.0

%changelog
* Sat Sep 17 2005 David Walluck <walluck@mandriva.org> 0:3.1.0-8mdk
- cairo 1.0 doesn't work out of the box

* Tue Sep 13 2005 David Walluck <walluck@mandriva.org> 0:3.1.0-7mdk
- fix build on x86_64
- fix startyp script
- fix ant script symlinks

* Sun Sep 11 2005 David Walluck <walluck@mandriva.org> 0:3.1.0-6mdk
- remove /usr/bin/mozilla requirement for eclipse-platform
- don't enable embedded mozilla-firefox browser by default (crashes)
- use eclipse-ecj (ecj-bootstrap) to build until gcj works again

* Thu Sep 08 2005 David Walluck <walluck@mandriva.org> 0:3.1.0-5mdk
- use mozilla-firefox instead of mozilla

* Tue Sep 06 2005 David Walluck <walluck@mandriva.org> 0:3.1.0-4mdk
- provide and obsolete ecj-bootstrap

* Mon Sep 05 2005 David Walluck <walluck@mandriva.org> 0:3.1.0-3mdk
- simplify mozilla-gtkmozembed cflags and libs

* Mon Sep 05 2005 David Walluck <walluck@mandriva.org> 0:3.1.0-2mdk
- update main and platform description with info about native libs
- remove patch32 (enable cairo)

* Fri Sep 02 2005 David Walluck <walluck@mandriva.org> 0:3.1.0-1mdk
- release

* Thu Jul 28 2005 Gary Benson <gbenson@redhat.com> 3.1.0_fc-12
- Allow leading separators in classpaths (e.o#105430).
- Clear away ant-jmf entirely.

* Wed Jul 27 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-11
- Bump release for FC4 update.

* Mon Jul 25 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-10
- Change mozilla BuildRequirement to be equals and not greater-than or equals
  since we need the exact version for our patches.
- Bump mozilla requirements and patches to 1.7.10.
- Bump release due to FC4 update still not being released.
- Add ant-jmf to exclude list.

* Tue Jul 19 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-7
- Remove ant-jmf symlinking and requirement.
- Update to use java-gcj-compat and not java-1.4.2-gcj-compat.

* Tue Jul 12 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-6
- Bump release to build against new gcc.
- Bump gcc requirement to gcc 4.0.1.
- Add back BuildArch until we get bootstrapping sorted out.
- Bump required version of java-gcj-compat to the latest (-40jpp_37rh).
- Remove lots of jiggery-pokery with native compilation and use gbenson's new
  aot-compile.
- Re-work files sections appropriately.
- Change mozilla-nspr-devel -> nspr-devel due to change in mozilla packaging.
- Update patch for mozilla build as per above.
- Add org.eclipse.osgi_3.1.0.jar to exclude.

* Tue Jul 05 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-5
- Revert ecj_bootstrap patch since it won't work.
- Keep mozilla requirement off ppc64.
- Add ant-apache-bsf requirement since we have that in FC5.

* Tue Jul 05 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-4
- Add ecj_bootstrap patch from Gary Benson to bootstrap new architectures.
- Remove ExclusiveArch.

* Tue Jul 05 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-3
- Bump release for FC4 update.

* Mon Jul 04 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-2
- Remove remaining pre-built ant jars (but don't symlink to ant.jar until we
  have ant 1.6.5 - rh#162444).
- Bump requirement on gcc to get fixes for rh#158614 and gcc#21637.
- Add patch to not try to link to external javadocs and include the javadoc
  output in the build output.
- Add build and runtime requirement on ant-javamail (I'm not sure how we missed
  this previously).

* Mon Jul  4 2005 Gary Benson <gbenson@redhat.com> 3.1.0_fc-2
- Disable classpath access rules introduced in e.o#92398 (rh#162177).

* Tue Jun 28 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-1
- Import 3.1.
- Update splash screen.

* Sun Jun 26 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.RC4.1
- Import 3.1 RC4.
- Remove activeHelpSample.jar building patch as it's now fixed upstream.
- Add patch to remove references to cairo since we don't have it in FC4.
- Add about.html and about_files to eclipse-platform.install (x86 & x86_64).
- Add patch to create public compare API (jpound - e.o#98707).
- Add patch from Robin Green to not look for firefox libxpcom.so (rh#161658).
- Symlink lucene jars (rh#159939).

* Fri Jun 24 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.RC3.3
- Add rcp requirement for platform (rh#161267).
- Add un-owned osgi directories to libswt and platform.

* Tue Jun 21 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.RC3.2
- Use SWT bundle ID for SWT %files list (determine in %%install).

* Mon Jun 20 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.RC3.1
- Import 3.1RC3.
- Use FileInitializer (e.o#90535) - this should eliminate .sos in ~/.eclipse.
- Add eclipse-filenamepatterns.txt ("*.so" currently) for above.
- Symlink JNI libraries.

* Fri Jun 17 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.RC2.2
- Update to new naming scheme for resulting gzipped tarball.
- Add patch to not generate help indices (it seems to hang).

* Thu Jun 16 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.RC2.1
- Import 3.1RC2.
- Add RCP sub-package.  Unsure about its dependencies ATM.

* Tue Jun 14 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M7.9
- Add tomcat5 patch and symlinks.

* Thu May 26 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M7.8
- Fix ant jar removal (gbenson).

* Wed May 25 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M7.7
- Fix ecj symlink in /usr/share/java (rh#158734).

* Sun May 22 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M7.4
- Remove compilation of jdt.ui jar.so on ppc.

* Sat May 21 2005 Ben Konrath <bkonrath@redhat.com> 3.1.0_fc-0.M7.3
- Add ecj-options patch to bootstrap source.
- Make embedded browser widget work (Robin Green).
- Bump required version of java-gcj-compat to the latest (-40jpp_24rh).
- Use -lgcjawt when building with gcj.

* Wed May 18 2005 Ben Konrath <bkonrath@redhat.com> 3.1.0_fc-0.M7.2
- Disable org.eclipse.osgi_3.1.0.jar.so.
- Add ecj-options patch, remove ecj-extdirs patch.

* Wed May 18 2005 Ben Konrath <bkonrath@redhat.com> 3.1.0_fc-0.M7.1
- Update to 3.1M7.
- Add file initializer patch.
- Temporarily remove s390{,x} patches.
- Update GNU formatter ui patch.
- Add ECJ ext dirs patch.

* Tue May 17 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M6.19
- Add Epoch on eclipse-platform.
- Use %%{_bindir} in post and postun scripts.

* Tue May 17 2005 Ben Konrath <bkonrath@redhat.com> 3.1.0_fc-0.M6.18
- Add Epoch to jsch requires.

* Mon May 16 2005 Ben Konrath <bkonrath@redhat.com> 3.1.0_fc-0.M6.17
- Update libswt-mozilla patches and require mozilla 1.7.8.
 
* Fri May 13 2005 Andrew Overholt <overholt@redhat.com>
- Use %%{ix86} macro in ExclusiveArch rather than i386 (jorton).

* Wed May 11 2005 Ben Konrath <bkonrath@redhat.com>
- Add jsch >= 0.1.18-1jpp.
- Remove Fedora specific part of junit version.
- Temporarily disable org.eclipse.ui.forms_3.1.0.jar.so (rh#146463).

* Mon May 09 2005 Ben Konrath <bkonrath@redhat.com> 3.1.0_fc-0.M6.16
- Add Requires junit >= 3.8.1-3jpp_4fc to JDT.
- Add -g to gcj calls.

* Thu May 05 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M6.15
- Rebuild with new gjdoc (rh#152049).

* Wed May 4 2005 Ben Konrath <bkonrath@redhat.com>
- Re-enable jdt.ui/jdt.jar.so and require gcj 4.0.0-2 (rh#151296).

* Mon May 2 2005 Ben Konrath <bkonrath@redhat.com> 3.1.0_fc-0.M6.14
- Replace temporary patch to debug.ui with upstream patch to swt (rh#155853).

* Sat Apr 30 2005 Ben Konrath <bkonrath@redhat.com> 3.1.0_fc-0.M6.13
- Add patch to temporarily stop an NPE in debug.ui (rh#155853).

* Thu Apr 28 2005 Phil Muldoon <pmuldoon@redhat.com>
- Allow multiple optional arguments in eclipse-copy-platform.sh 

* Wed Apr 27 2005 Andrew Overholt <overholt@redhat.com>
- Include epoch in mozilla BuildRequires.
- Remove last remaining gij-specific option from eclipse.script.

* Wed Apr 27 2005 Jeremy Katz <katzj@redhat.com> 3.1.0_fc-0.M6.12
- silence %%post

* Sun Apr 24 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M6.11
- Re-add osgi.jar.so since gcj fix is in our gcc RPMs.
- Bump gcc requirements accordingly.
- Add gcc-c++ to BuildRequires (for SWT Mozilla).
- Add specific java-1.4.2-gcj-compat nvr requirement (rh#151866).

* Fri Apr 22 2005 Aaron Luchko <aluchko@redhat.com> 3.1.0_fc-0.M6.10
- Import archived projects (e.o#82988)

* Fri Apr 22 2005 Andrew Overholt <overholt@redhat.com>
- Add Requires(post,postun): java-1.4.2-gcj-compat for each sub-package and use
  full path (Joe Orton).
- Make /usr/bin/eclipse executable again (rh#155715).
- Bump jsch version.

* Thu Apr 21 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M6.9
- Use upstream icons (not RHDS ones) (rh#146484).
- Add plugin directories to %files sections.
- Rework %files sections a bit.
- Fix SWT symlink (bkonrath).
- Temporarily remove jdt.ui/jdt.jar.so.

* Thu Apr 21 2005 Ben Konrath <bkonrath@redhat.com> 3.1.0_fc-0.M6.8
- Fix updatesite patch.
- Temporarily remove org.eclipse.ui.workbench_3.1.0.jar.so (r.c#151919)

* Mon Apr 18 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M6.7
- Add %if %%{gcj_support} blocks.
- Add %%{_libdir}/%%{name}/plugins to native %files section of each sub-rpm.
- Add GNU-style JDT code formatting option (e.o#91770).
- Add patch to install plugins from update site in home dir (e.o#90630).
- Change gcc-java requirements to libgcj as gcj-dbtool is now in the latter.

* Mon Apr 18 2005 Ben Konrath <bkonrath@redhat.com> 3.1.0_fc-0.M6.6
- Bump version number. 

* Mon Apr 18 2005 Ben Konrath <bkonrath@redhat.com> 3.1.0_fc-0.M6.5
- Update mozilla patch.

* Sat Apr 16 2005 Ben Konrath <bkonrath@redhat.com> 3.1.0_fc-0.M6.4
- Update to 3.1M6.
- Change bootstrap procedure to match the upstream method.
- Remove patches that were fixed upstream. 
- Add efj wrapper script.

* Wed Apr 13 2005 Ben Konrath <bkonrath@redhat.com> 3.1.0_fc-0.M5.20
- Fix the bootstrap patch (the ecj jar was missing some files).

* Tue Apr 12 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M5.19
- Add Requires(post,postun): java-1.4.2-gcj-compat for rebuild-gcj-db (Joe
  Orton).
- Add ecj binary.

* Wed Apr 06 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M5.18
- Fix typo in gcj db building loops.
- Add -O1 to x86_64 jar.so compilation.
- Add EFJ (Eclipse Formatter for Java) patches (bkonrath) (e.o#75333).
- Add patch to build swttools.jar (e.o#90364).
- Symlink out to ant-jsch now that we have that.

* Mon Apr 04 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M5.17
- Actually insert .jar-.jar.so combinations into sub-dbs.

* Thu Mar 31 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M5.16
- Fix eclipse.script to not leave a sh process around (Joe Orton)
- Use proper sub-dbs.
- Don't compile jars that are symlinked from elsewhere.
- Add jar-so combinations to .db based on .jar.so existence (not .jar).
- Rename sub-dbs to be eclipse-*.db.
- Use rebuild-gcj-db script.

* Mon Mar 28 2005 Christopher Aillon <caillon@redhat.com>
- rebuilt

* Fri Mar 25 2005 Christopher Aillon <caillon@redhat.com> 3.1.0_fc-0.M5.14
- Update the GTK+ theme icon cache on (un)install

* Fri Mar 18 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M5.13
- Re-add compilation of resources.jar.
- Backport bootstrapping patch.
- Add Requires: java-1.4.2-gcj-compat.
- Modified find patch courtesy Ziga Mahkovec (RH#149927#).
- Compile with -O2 on ppc as well.
- Add jsch, jakarta-commons-modeler, and mx4j symlinking.
- Make use of gcj-dbtool -f to create databases in install.
- Use system-wide classmap.db.
- Remove *.jarswithnativelibs from files sections.
- Update mozilla dependency.

* Mon Mar 07 2005 Ben Konrath <bkonrath@redhat.com> 3.1.0_fc-0.M5.12
- Add activeHelpSample.jar patch.
- Change to Fedora M-build splash screen.
- Add find patch courtesy Ziga Mahkovec (RH#149927#)
- Build native stuff with -O2 on i386.

* Mon Mar 07 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M5.11
- Add s390 and s390x patches.
- Don't build for them, though, due to gcc bug and Eclipse building issue.
- Add xorg-x11-devel BuildRequires.

* Fri Mar 04 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M5.10
- Add proper mozilla version.
- Don't build eclipseAdaptor.jar.so in order to work around plugin building
  problems.

* Thu Mar 03 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M5.9
- Add patch to build libswt-mozilla.
- Build libswt-awt.
- Add 64-bit swt lib list.

* Tue Mar 01 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M5.8
- Add ppc.
- Add patch to copy over icon for unsupported (upstream) platforms but don't
  include the source for the launcher.
- gcc4 -> gcc changes.
- Add swt-cairo to 64-bit platforms' %files.

* Fri Feb 25 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M5.7
- Add tar args patch (e.o #86571).
- New build bootstrapping patches.

* Fri Feb 25 2005 Andrew Overholt <overholt@redhat.com> 3.1.0_fc-0.M5.6
- Re-work how we do the gcj-dbtool magic.
- Don't remove ant-netrexx (need to find an RPM if we can).

* Sun Feb 20 2005 Andrew Overholt <overholt@redhat.com> 1:3.1_fc-0.M5.5
- Build for just i386 and x86_64 for now due to upstream gcc bugs.

* Sun Feb 20 2005 Andrew Overholt <overholt@redhat.com> 1:3.1_fc-0.M5.1
- New 3.1M5a build using upstream build method.
- Re-organize sub-packages (ecj, platform, platform-devel, jdt, jdt-devel, pde,
  pde-devel, fold gtk2 package into platform).
- Move jface and org.eclipse.text into libswt3-gtk2.
- Bring in JPackage symlinks for packages we have in Fedora (David Walluck) and
  put in %%prep.
- Work around x86_64 filename differences.
- Remove xerces, xalan, and xml-commons-apis requirement (and LD_PRELOAD from
  script).
- Bootstrap build.
